package uloha1;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

public class SadaUsecek implements SadaUsecekInterface {
    List<Usecka> al = new ArrayList<Usecka>();

    public void pridejUsecka(Usecka u) {
        al.add(u);
    }

    public void odeberUsecku(Usecka u) throws UseckaNeniException {
        if (al.contains(u)) al.remove(u);
        throw new UseckaNeniException();
    }

    public Iterator<Usecka> iterate() {
        return al.iterator();
    }

    /*
     * Metoda na rozdil od cviceni predpoklada, ze objekty jsou jiz normalizovany. Tato normalizace
     * je zajistena volanim metody normalizuj primo v konstruktoru tridy Usecka     
     */
    public void setridUsecky() {
        Collections.sort(al);        
    }
    
    /*
     * Metoda na rozdil od cviceni predpoklada, ze objekty jsou jiz normalizovany. Tato normalizace
     * je zajistena volanim metody normalizuj primo v konstruktoru tridy Usecka     
     */
    public void setridUsecky(Comparator<Usecka> comp) {
        Collections.sort(al,comp);
    }
}
