/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package uloha1;

import java.awt.Point;

/**
 *
 * @author nav79
 */
public class Usecka implements Comparable<Usecka> {

    private Point bodA;
    private Point bodB;

    
    public Usecka(Point bodA, Point bodB) {
        this.bodA = bodA;
        this.bodB = bodB;
        normalizuj();
    }

    public Point getBodB() {
        return bodB;
    }

    public void setBodB(Point bodB) {
        this.bodB = bodB;
    }

    public Point getBodA() {
        return bodA;
    }

    public void setBodA(Point bodA) {
        this.bodA = bodA;
    }

    public void normalizuj() {
        if (bodB.x < bodA.x) {
            swap();
        } else if (bodB.x == bodA.x && bodB.y < bodA.y) {
            swap();
        }
    }

    @Override
    public String toString() {
        return String.format("([%1$d,%2$d];[%3$d,%4$d])", bodA.x,bodA.y,bodB.x,bodB.y);
    }

    
    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Usecka other = (Usecka) obj;
        if (this.bodA != other.bodA && (this.bodA == null || !this.bodA.equals(other.bodA))) {
            return false;
        }
        if (this.bodB != other.bodB && (this.bodB == null || !this.bodB.equals(other.bodB))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 97 * hash + (this.bodA != null ? this.bodA.hashCode() : 0);
        hash = 97 * hash + (this.bodB != null ? this.bodB.hashCode() : 0);
        return hash;
    }

    public int compareTo(final Usecka other) {
        
        if (bodA.equals(other.bodA) && bodB.equals(other.bodB)) {
            return 0;
        }
        if (bodA.x < other.bodA.x || (bodA.x == other.bodA.x && bodA.y< other.bodA.y)) {
            return -1;
        }
        return 1;
    }

    private void swap() {
        Point pom = bodA;
        bodA = bodB;
        bodB = pom;
    }
}
